/*
 * btnhnd.c
 *
 * (c) Copyright by Willem van Engen
 * See COPYRIGHT for copyright
 * See CREDITS for credits
 */
#include <sys/types.h>
#include <machine/cpufunc.h>
#include <stdlib.h>
#include "cdev.h"

#define BASEPORT	0xff80

#define AP_DEV_BTN_APPL	0x30
#define AP_DEV_BTN_CD	0x34
#define AP_DEV_BTN_OUT	0x34
#define AP_DEV_LED	0x30
#define AP_DEV_LCD	0x34
#define AP_MIN_LCD_SET	0x06

#define AP_MIN_CD	1
#define AP_MIN_APPL	8

/* keyloc is CD or APPL */
unsigned int getdevice(char device,char minor) {
  outb(BASEPORT+4,device|1);
  outb(BASEPORT+3,minor);

  outb(BASEPORT+2,(inb(BASEPORT+2)&0x1c)|0x0c);
  if (applysub()==0) {
    /* Error */
    return 0;
  }
  return (((unsigned int)inb(BASEPORT+6))<<16) + inb(BASEPORT+5);
}

unsigned int __inline setled(unsigned int timing) {
  return setdevice(AP_DEV_LED,timing>>16,timing&0xffff);
}
unsigned int __inline setlcd(unsigned int number) {
  return setdevice(AP_DEV_LCD,number>>16,number&0xffff);
}
unsigned int getbtn(unsigned int* b2) {
  unsigned int keys;

  keys=getdevice(AP_DEV_BTN_APPL,AP_MIN_APPL);
  *b2=getdevice(AP_DEV_BTN_CD,AP_MIN_CD);
  setdevice(AP_DEV_BTN_OUT,1,0);
  return keys;
}

unsigned int setdevice(char device, char minor, unsigned int number) {
  outb(BASEPORT+4,device);
  outb(BASEPORT+5,(char)number&&0xff);
  outb(BASEPORT+6,(char)(number>>8));

  outb(BASEPORT+3,(char)minor);
  outb(BASEPORT+2,(inb(BASEPORT+2)&0x1c)|0x0c); if (applysub()==0) {
    /* Error */
    return 0;
  }
  return 1;
}

int applysub(void) {
  outb(BASEPORT  ,inb(BASEPORT  )|0x1e);
  outb(BASEPORT+1,inb(BASEPORT+1)|0x3c);
  outb(BASEPORT+2,inb(BASEPORT+2)|0x40);
  /* TODO if applicable in FreeBSD :) */
  /* Some nest-exec???? */
  /*  if (inb(BASEPORT)&0x1f!=0x1c) */

  outb(BASEPORT,inb(BASEPORT)|2);
  return 1;
}

