/* 08 Nov 1998*/
/*
 * cdev.h - header for sample kld module implementing a character device
 *          driver.
 *
 * 08 Nov 1998  Rajesh Vaidheeswarran
 *
 * Copyright (c) 1998 Rajesh Vaidheeswarran
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Rajesh Vaidheeswarran.
 * 4. The name Rajesh Vaidheeswarran may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY RAJESH VAIDHEESWARRAN ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE RAJESH VAIDHEESWARRAN BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright (c) 1993 Terrence R. Lambert.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Terrence R. Lambert.
 * 4. The name Terrence R. Lambert may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TERRENCE R. LAMBERT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TERRENCE R. LAMBERT BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
/*
 * Fujitsu C-4110 application panel driver
 * See http://www.stack.nl/~wvengen/fujitsu/ and README for details
 *
 * Copyright by Willem van Engen <wvengen@stack.nl>
 * See COPYRIGHT for copyright
 * See CREDITS for credits
 *
 */

#ifndef __CDEV_H_
#define __CDEV_H_

#include <sys/conf.h>
#include "local.h"

d_open_t mydev_open;
d_close_t mydev_close;
d_write_t mydev_write;
d_read_t mydev_read;

#define CDEV_MAJOR	127

#define WRITEBUFSIZE	10

#ifdef __FREEBSD3__
/* The FreeBSD 3.x chardevice structure */
static struct cdevsw my_devsw = {
    mydev_open,
    mydev_close,
    mydev_read,
    mydev_write,
    noioctl,
    nostop,
    nullreset,
    NULL,
    nommap,
    NULL,
    "apanel",
    NULL,
    CDEV_MAJOR
};
#elif defined __FREEBSD4__
/* This works for FreeBSD 4.1 */
static struct cdevsw my_devsw = {
    mydev_open,
    mydev_close,
    mydev_read,
    mydev_write,
    noioctl,		/* ioctl */
    NULL,		/* poll */
    nommap,		/* mmap */
    nostrategy,		/* strategy */
    "apanel",		/* device name */
    CDEV_MAJOR,		/* d_maj */
    nodump,		/* dump */
    nopsize,		/* psize */
    0,			/* flags */
    -1			/* d_bmaj */
};
#else
  #error Please define an operating system and version (or run the install script)
#endif

/* Other function prototypes */
unsigned int getdevice(char,char);
unsigned int setled(unsigned int);
unsigned int setlcd(unsigned int);
unsigned int getbtn(unsigned int*);
unsigned int setdevice(char,char,unsigned int);
int applysub(void);

#endif 
